﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var TabManager;
(function (TabManager) {
    var TabCellTypeStyleTemplateHelper = (function (_super) {
        __extends(TabCellTypeStyleTemplateHelper, _super);
        function TabCellTypeStyleTemplateHelper() {
            var _this = _super.call(this) || this;
            _this.CellTypeString = "TabManager.TabManager";
            _this.TemplateNameParts = ["TabItem"];
            return _this;
        }
        TabCellTypeStyleTemplateHelper.prototype.MapPartsNameToDom = function (container) {
            return {
                TABITEM: container.find("." + "FTM-nav-wrap-list-item")
            };
        };
        TabCellTypeStyleTemplateHelper.prototype.OnTemplateStyleApplied = function (styleTemplate, container) {
            if (container) {
                container.css("overflow", "visible");
                if (styleTemplate &&
                    styleTemplate.Styles &&
                    styleTemplate.Styles["TabItem"] &&
                    styleTemplate.Styles["TabItem"].SelectedStyle) {
                    var activeStyle = styleTemplate.Styles["TabItem"].SelectedStyle;
                    if (activeStyle.Background) {
                        var backgroundColor = Forguncy.ConvertToCssColor(activeStyle.Background);
                        container.find("." + "FTM-nav").css('border-bottom-color', backgroundColor);
                    }
                }
            }
        };
        return TabCellTypeStyleTemplateHelper;
    }(TabManager.CellTypeStyleTemplateHelperBase));
    TabManager.TabCellTypeStyleTemplateHelper = TabCellTypeStyleTemplateHelper;
    var TabCellType = (function (_super) {
        __extends(TabCellType, _super);
        function TabCellType() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TabCellType.prototype.getStyleTemplateHelper = function () {
            return TabCellType.StyleTemplateHelper;
        };
        TabCellType.prototype.createContent = function () {
            var cellType = this.CellElement.CellType;
            var tabStyle = this.CellElement.StyleTemplate;
            var container = $("<div style=\"width:100%;height:100%;\" />");
            this.tabManager = new TabManager.TabContainer(cellType, tabStyle, this._pageID);
            container.append(this.tabManager.createUI().container);
            return container;
        };
        TabCellType.prototype.onWindowResized = function () {
            this.tabManager.dispatch("WindowResized");
        };
        TabCellType.prototype.destroy = function () {
            TabManager.TabContainer.clearTabContainerInstanceCache(this._pageID);
            _super.prototype.destroy.call(this);
        };
        TabCellType.StyleTemplateHelper = new TabCellTypeStyleTemplateHelper();
        return TabCellType;
    }(Forguncy.Plugin.CellTypeBase));
    TabManager.TabCellType = TabCellType;
    function getQuery(queryString) {
        var query = window.location.search.substring(1);
        var vars = query.split("&");
        for (var i = 0; i < vars.length; i++) {
            if (vars[i].indexOf(queryString) === 0) {
                try {
                    return decodeURIComponent(vars[i].substring(queryString.length + 1));
                }
                catch (e) {
                    return null;
                }
            }
        }
    }
    Forguncy.Page.ready(function () {
        var passvalueStr = getQuery(TabManager.TabPassValue);
        if (passvalueStr) {
            var passvalue = JSON.parse(passvalueStr, Common.dateReviver);
            for (var cellName in passvalue) {
                try {
                    var cell = Forguncy.Page.getCell(cellName);
                    if (cell) {
                        cell.setValue(passvalue[cellName]);
                    }
                }
                catch (_a) {
                    continue;
                }
            }
        }
    });
    var Common = (function () {
        function Common() {
        }
        Common.dateReviver = function (key, value) {
            var a;
            if (typeof value === 'string') {
                a = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                if (a) {
                    return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4], +a[5], +a[6]));
                }
            }
            return value;
        };
        return Common;
    }());
    var TabOpenCommand = (function (_super) {
        __extends(TabOpenCommand, _super);
        function TabOpenCommand() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TabOpenCommand.prototype.execute = function () {
            var _this = this;
            var commandSettings = this.CommandParam;
            var urlTitle = this.evaluateFormula(commandSettings.UrlTitle);
            var pageName = this.evaluateFormula(commandSettings.PageName);
            var url = this.evaluateFormula(commandSettings.Url);
            var isSelectPage = commandSettings.IsSelectPage;
            var passedValueList = commandSettings.PassedValueList || [];
            var usedMode = commandSettings.UsedMode;
            var data = passedValueList.filter(function (item) {
                return item && item.Target;
            }).reduce(function (pre, cur) {
                var source = _this.evaluateFormula(cur.Source);
                var target = _this.evaluateFormula(cur.Target);
                pre[target] = source;
                return pre;
            }, {});
            var tab = new TabManager.Tab(isSelectPage, pageName, url, urlTitle, usedMode, data);
            TabManager.TabContainer.addTab(tab, Forguncy.ForguncyData.pageInfo.pageID);
        };
        return TabOpenCommand;
    }(Forguncy.Plugin.CommandBase));
    TabManager.TabOpenCommand = TabOpenCommand;
    var ResourceHelper = (function () {
        function ResourceHelper() {
        }
        ResourceHelper.getResourceString = function (key) {
            var culture;
            if (Forguncy && Forguncy.RS && Forguncy.RS.Culture) {
                culture = Forguncy.RS.Culture;
            }
            else {
                culture = "EN";
            }
            if (ResourceHelper.resourceMap[culture]) {
                return ResourceHelper.resourceMap[culture][key];
            }
            return "";
        };
        ResourceHelper.resourceMap = {
            CN: {
                alert_message_invalid_URL: "无效的URL！请提供以http://或者http://开头的完整URL。"
            },
            JA: {
                alert_message_invalid_URL: "Invalid URL! Please provide complete URL starting with http:// or https://"
            },
            KR: {
                alert_message_invalid_URL: "유효하지 않은 URL입니다! http:// or https:// 로 시작하는 정상적인 URL을 입력해 주세요."
            },
            EN: {
                alert_message_invalid_URL: "Invalid URL! Please provide complete URL starting with http:// or https://"
            }
        };
        return ResourceHelper;
    }());
    TabManager.ResourceHelper = ResourceHelper;
})(TabManager || (TabManager = {}));
Forguncy.Plugin.CellTypeHelper.registerCellType("TabManager.TabCellType, TabManager", TabManager.TabCellType);
Forguncy.Plugin.CommandFactory.registerCommand("TabManager.TabOpenCommand, TabManager", TabManager.TabOpenCommand);
