﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var TabManager;
(function (TabManager) {
    var TabHeadUI = (function (_super) {
        __extends(TabHeadUI, _super);
        function TabHeadUI() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(TabHeadUI.prototype, "activeTab", {
            set: function (value) {
                this.navWrap.find("." + "FTM-nav-wrap-list-item").removeClass("selected");
                if (value) {
                    var activeTab = this.navWrap.find("." + "FTM-nav-wrap-list-item" + "[data-uid=\"" + value.uid + "\"]");
                    activeTab.addClass("selected");
                    this.revealItem(activeTab);
                }
            },
            enumerable: true,
            configurable: true
        });
        TabHeadUI.prototype.createContainer = function () {
            this.container = $("<div class=\"" + "FTM-nav" + "\"></div>");
        };
        TabHeadUI.prototype.createContainerEvents = function () {
            var _this = this;
            _super.prototype.createContainerEvents.call(this);
            this.target.on("TabsChange", function () {
                _this.createTabs();
            });
            this.target.on("WindowResized", function () {
                _this.updateNav();
            });
        };
        Object.defineProperty(TabHeadUI.prototype, "hasEnoughWidth", {
            get: function () {
                var containerWidth = this.container[0].clientWidth;
                var tabItemsTotalWidth = 0;
                this.navWrap
                    .find("." + "FTM-nav-wrap-list-item")
                    .each(function (index, el) {
                    tabItemsTotalWidth += $(el).width();
                });
                return tabItemsTotalWidth <= containerWidth;
            },
            enumerable: true,
            configurable: true
        });
        TabHeadUI.prototype.createChildren = function () {
            var _this = this;
            this.navPrev = $("<div class='" + "FTM-nav-prev" + "'></div>");
            this.navNext = $("<div class='" + "FTM-nav-next" + "'></div>");
            this.navMenu = this.target.createUI(TabManager.TabMenuUI).container;
            this.navPrev.on('click', function () {
                _this.movePrev();
            });
            this.navNext.on('click', function () {
                _this.moveNext();
            });
            this.navWrap = $("\n<nav class=\"" + "FTM-nav-wrap" + "\">\n    <div class=\"" + "FTM-nav-wrap-placeholder" + "\"><ul class=\"" + "FTM-nav-wrap-list" + "\"></ul></div>\n</nav>");
            this.createTabs();
            this.container.append(this.navPrev, this.navNext, this.navWrap, this.navMenu);
        };
        Object.defineProperty(TabHeadUI.prototype, "styleTemplateClassName", {
            get: function () {
                if (!this.target.tabStyle) {
                    return "";
                }
                return "TabManagerTabCellType-" + this.target.tabStyle.Key + "-TabItem";
            },
            enumerable: true,
            configurable: true
        });
        TabHeadUI.prototype.revealItem = function (item) {
            if (item.length === 0) {
                return;
            }
            var navWrapOffsetLeft = this.navWrap.offset().left;
            var navWrapWidth = this.navWrap.width();
            var itemOffsetLeft = item.offset().left;
            var itemWidth = item.width();
            var placeholder = this.navWrap.find("." + "FTM-nav-wrap-placeholder");
            var currentMarginLeft = parseFloat(placeholder.css('margin-left'));
            var usedMarginLeft = currentMarginLeft;
            if (itemOffsetLeft < navWrapOffsetLeft) {
                usedMarginLeft += navWrapOffsetLeft - itemOffsetLeft;
            }
            else if (navWrapOffsetLeft + navWrapWidth <= itemOffsetLeft + itemWidth) {
                usedMarginLeft -= itemOffsetLeft + itemWidth - navWrapOffsetLeft - navWrapWidth;
            }
            placeholder.animate({
                "margin-left": usedMarginLeft + "px"
            }, TabHeadUI.aminateSpeed);
        };
        TabHeadUI.prototype.moveNext = function () {
            var placeholder = this.navWrap.find("." + "FTM-nav-wrap-placeholder");
            var navWrapWidth = this.navWrap.width();
            var navList = this.navWrap.find("." + "FTM-nav-wrap-list");
            var navListWidth = navList.children().map(function (v, d) { return $(d).width(); }).toArray().reduce(function (p, n) { return p + n; });
            if (navListWidth <= navWrapWidth) {
                return;
            }
            var currentMarginLeft = parseFloat(placeholder.css('margin-left'));
            var marginLeftLimit = navListWidth - navWrapWidth;
            var targetMarginLeft = currentMarginLeft - TabHeadUI.navStep;
            var usedMarginLeft = Math.max(-marginLeftLimit, targetMarginLeft);
            placeholder.animate({
                "margin-left": usedMarginLeft + "px"
            }, TabHeadUI.aminateSpeed);
        };
        TabHeadUI.prototype.movePrev = function () {
            var placeholder = this.navWrap.find("." + "FTM-nav-wrap-placeholder");
            var currentMarginLeft = parseFloat(placeholder.css('margin-left'));
            var targetMarginLeft = currentMarginLeft + TabHeadUI.navStep;
            var usedMarginLeft = Math.min(0, targetMarginLeft);
            placeholder.animate({
                "margin-left": usedMarginLeft + "px"
            }, TabHeadUI.aminateSpeed);
        };
        TabHeadUI.prototype.createTabs = function () {
            var _this = this;
            var newTabs = this.target.tabList.map(function (v) {
                var link = $("<a class=\"" + "FTM-nav-wrap-list-item-link" + " " + "FTM-f-ellipsis" + "\"></a>");
                link.text(v.displayedTitle);
                var tab = $("<li data-uid=\"" + v.uid + "\" class=\"" + "FTM-nav-wrap-list-item" + " " + _this.styleTemplateClassName + "\"></li>")
                    .on("click", function () {
                    _this.target.active(v);
                });
                tab.attr("title", v.displayedTitle).append(link);
                if (v === _this.target.activeTab) {
                    tab.addClass("selected");
                }
                if (v.canBeClosed) {
                    var close_1 = $("<i class=\"" + "FTM-nav-wrap-list-item-close" + "\"></i>").on("click", function () {
                        _this.target.closeTab(v);
                    });
                    tab.find("." + "FTM-nav-wrap-list-item-link").append(close_1);
                }
                return tab;
            });
            var navList = this.navWrap.find("." + "FTM-nav-wrap-list");
            navList.empty();
            navList.append.apply(navList, newTabs);
            this.updateNav();
        };
        TabHeadUI.prototype.updateNav = function () {
            if (this.isNavReady === false) {
                return;
            }
            if (this.hasEnoughWidth) {
                this.navPrev.hide();
                this.navNext.hide();
                this.navMenu.hide();
                this.movePrev();
            }
            else {
                this.navPrev.show();
                this.navNext.show();
                this.navMenu.show();
            }
        };
        Object.defineProperty(TabHeadUI.prototype, "isNavReady", {
            get: function () {
                return !!(this.navPrev || this.navNext || this.navMenu);
            },
            enumerable: true,
            configurable: true
        });
        TabHeadUI.navStep = 500;
        TabHeadUI.aminateSpeed = 150;
        return TabHeadUI;
    }(TabManager.ControlUIBase));
    TabManager.TabHeadUI = TabHeadUI;
})(TabManager || (TabManager = {}));
